

import ddf.minim.*;

AudioSample[] samp;
Makeorbs[] orbs;
int SampNum = 40;

void setup()
{
  size(600, 600);
  Minim.start(this);
  orbs = new Makeorbs[SampNum];
  samp = new AudioSample[SampNum];
  for (int i = 0; i < SampNum; i++) {
    samp[i] = Minim.loadSample("samp" + i + ".wav", 512);
  }
 int x = 80;
 int y = 80;
 float scaler = 10;
 float colR = 0, colG = 0, colB = 0;
  //this for loop makes our 400 orb instances and sends with them a position, scale, and random color
 for (int i = 0; i < SampNum; i++){
    orbs[i] = new Makeorbs(x, y, scaler, colR, colG, colB);
    x += 100;
    colR = random(255);
    colG = random(255);
    colB = random(255);
    if (x > 600) {
      x = 80;
      y += 100;

    }
  }
}

void draw()
{
  fill (255, 20);
  rect(0, 0, width, height);
  stroke(255);
  for (int i = 0; i < SampNum; i++) {
    float[] goSamp = samp[i].mix.toArray();
    for (int m = 0; m < samp[i].bufferSize() - 1; m++) {
      //line(m, 50 - goSamp[m]*50, m+1, 50 - goSamp[m+1]*50);
      orbs[i].update(goSamp[m]*10, mouseY);
    }
    orbs[i].display();
  }
}

void keyPressed()
{
  for (int k = 91; k < (SampNum + 91); k++) {
    if ( key == char(k) ) samp[k-91].trigger();
  }
  
}

class Makeorbs {
  int Ox, Oy;
  float scaler, R, G, B ;
  Makeorbs(int x, int y, float Oscale, float OR, float OG, float OB) {
    Ox = x;
    Oy = y;
    scaler = Oscale;
    R = OR;
    G = OG;
    B = OB;
  }

  void update(float mx, int my) {
    
    scaler += mx;  //make it bigger if hit
    
    if(scaler > 10) { 
      scaler -= 1;  //make it shrink if it is not hit
    } 
    else {
      scaler = 10;
    }
  }

  void display() { //display the finished orb
    fill(R, G, B, 80);
    ellipse(Ox, Oy, scaler, scaler);
  }
}



void stop()
{
 for (int j = 0; j< SampNum; j++) {
   samp[j].close();
 }
  super.stop();
}
